#!/usr/bin/perl

use Config; 	# in order to get some perl config infoz
$|++;

# what platform are we on?

if($^O=~/win/i){	$SEP="\\";
} elsif ($^O=~/mac/i){	$SEP=":";
} else {		$SEP="/"; }

# whisker make file

$VERSION	=	"pr3";
$LIB		=	"libwhisker.pm";
$COMPONENTS	= 	".".$SEP."libs".$SEP;
$PRELIB		=	"prelib.wpl";
$GLOBALS	=	"globals.wpl";
$NOPODSCRIPT	=	".".$SEP."scripts".$SEP."nopod.pl";

#### end config ######################################################
$NOPOD=$INSTALL=0; $BUILDEXIT=1;

if($ARGV[0] eq ''){
	print <<EOT
libwhisker build options:
- Makefile.pl lib	# make libwhisker

- Makefile.pl nopod	# strip pod out of libwhisker (and build it if 
			# it's not already built)

- Makefile.pl clean	# clean up the build tree

- Makefile.pl selfload	# add SelfLoader code to libwhisker (potentially
			# making it load faster in your programs

- Makefile.pl install	# install libwhisker into your local perl site 
			# module directory

- Makefile.pl uninstall	# remove libwhisker from the perl module directory

- Makefile.pl support	# check to see what supporting modules are 
			# available (i.e. installed on this machine)

EOT
;
exit;}


if($ARGV[0] eq 'support'){

	print "Socket ->\t";
	eval "use Socket";
	if(@_){ print "no\n"; } 
	else {  print "yes (version $Socket::VERSION)\n";}

	print "libwhisker ->\t";
	eval "use libwhisker";
	if(@_){ print "no\n"; } 
	else {  print "yes (version $lw::VERSION)\n";}

	print "lw::bin ->\t";
	eval "use lw::bin";
	if(@_){ print "no\n"; } 
	else {  print "yes (version $lw::bin::VERSION)\n";}

	print "Net::SSLeay ->\t";
	eval "use Net::SSLeay";
	if(@_){ print "no\n"; } 
	else {  print "yes (version $Net::SSLeay::VERSION)\n";}

	print "Net::SSL ->\t";
	eval "use Net::SSL";
	if(@_){ print "no\n"; } 
	else {  print "yes (version $Net::SSL::VERSION)\n";}

	exit;
}


eval "use Socket";
if(@_){
print STDOUT <<EOT
!! Warning !! 
   Your perl version doesn't have Socket (e.g. network) support;
   while you can still use libwhisker on this machine, all the network 
   functionality (which is the core purpose of libwhisker) will not be 
   available.  Of course, this doesn't apply if you're building
   libwhisker for use on another machine (which *does* have Socket 
   support).

EOT
;}

if($ARGV[0] eq 'clean'){
	unlink $LIB;
	print "Clean.\n";
	exit;
}

if($ARGV[0] eq 'uninstall'){
	my $where=$Config{'installsitelib'};
	if(-e "$where$SEP$LIB"){
		unlink "$where$SEP$LIB";
		print STDOUT "libwhisker uninstalled.\n";
	} else {
		print STDOUT "libwhisker not installed.\n";
	}
	exit;
}

if($ARGV[0] eq 'nopod'){
	$NOPOD=1;
	if(!(-e $LIB)){
		$ARGV[0]='lib';
		$BUILDEXIT=0; }
}

if($ARGV[0] eq 'install'){
	$INSTALL=1;
	if(!(-e $LIB)){
		$ARGV[0]='lib'; 
		$BUILDEXIT=0; }
}

if($ARGV[0] eq 'lib' || $ARGV[0] eq 'selfload'){
	open(OUT,">$LIB");
	print OUT "# libwhisker v$VERSION\n";
	open(IN,"<$COMPONENTS$PRELIB") || puke($PRELIB);
	while(<IN>){ print OUT; } close(IN);
	print OUT "\$VERSION=\"$VERSION\";\n";
	if($ARGV[0] eq 'selfload'){
		print OUT "use SelfLoader;\n";}
	open(IN,"<$COMPONENTS$GLOBALS") || puke($GLOBALS);
	while(<IN>){ print OUT; } close(IN);
	if($ARGV[0] eq 'selfload'){
		print OUT "1;\n__DATA__\n";}
	&readlibs;	
	print OUT "1;\n";
	print STDOUT "libwhisker built.\n";
	close(OUT);
	exit if $BUILDEXIT;
}

if($NOPOD){
	open(OUT,">$LIB.nopod");
	open(IN,"perl $NOPODSCRIPT $LIB |");
	while(<IN>){print OUT;} close(IN);
	close(OUT);
	unlink $LIB;
	rename "$LIB.nopod",$LIB;
	print STDOUT "POD removed.\n";
	exit;
}

if($INSTALL){
	my $where=$Config{'installsitelib'};
	open(IN,"<$LIB");
	open(OUT,">$where$SEP$LIB");
	while(<IN>){ print OUT; }
	close(IN); close(OUT);
	if(-s "$where$SEP$LIB"){
		 print STDOUT "libwhisker installed to $where$SEP\n";
	} else { print STDOUT "Error installing libwhisker\n"; }
}


exit;


sub puke {
	my $file = shift;
	print STDOUT "Build error: missing $file\n";
	eval "close(OUT)";
	exit;
}

sub readlibs {
	my $file;
	opendir(DIR,$COMPONENTS);
	while($file=readdir(DIR)){
		if($file=~/\.pl$/){
			open(IN,"<$COMPONENTS$file");
			while(<IN>){ print OUT; } close(IN);
		}
	}
	closedir(DIR);
}

	
