
=pod    


=head1 ++ Sub package: auth
        
The auth sub package implements HTTP authentication routines.

=cut

########################################################################
=pod    

=head1 - Function: lw::auth_brute_force
        
Params: $auth_method, \%hin, $user, \@passwords
Return: $first_valid_result

Perform a HTTP authentication brute force against a server (host and URI 
defined in %hin).  It will try every password in the password array for 
the given user.  The first password (in conjunction with the given user) 
that doesn't return HTTP 401 is returned (and the brute force is stopped 
at that point).

=cut
sub auth_brute_force {
 my ($auth_method, $reqref, $user, $pwordref)=@_;
 my ($P,%hout);

 map {
    ($P=$_)=~tr/\r\n//d; next if($P eq '');
    &lw::auth_set_header($auth_method,$reqref,$user,$P);
    &lw::http_do_request($reqref,\%hout);
    if($hout{'whisker'}->{'http_resp'} ne 401){
        return $P;}
 } @$pwordref;

 return '';}


########################################################################
=pod

=head1 - Function: lw::auth_set_header

Params: $auth_method, \%hin, $user, $passwords
Return: nothing (modifies %hin)

Set the appropriate authentication header in %hin.

=cut
sub auth_set_header {
 my ($method, $href, $user, $pass)=@_;

 if($method eq 'basic'){
    $$href{'Authorization'}='Basic '.&lw::encode_base64($user.':'.$P,'');
 }

 if($method eq 'digest'){

 # digest is tricky...how do we get the initial nonce (and realm)?  Can we
 # generate and send our own...do servers really check it?

 # we must send:
 # Digest username="", realm="", nonce="", digest-uri="", response=""

 }

}


########################################################################
