
=pod


=cut

################################################################
=pod

=head1 - Function: lw::html_find_tags
  
Params: \$data, \&callback_function
Return: nothing

lw::html_find_tags parses a piece of HTML and 'extracts' all found tags,
passing the info the given callback function.  The callback function must
accept two parameters: the current tag (as a scalar), and a hash ref of
all the tag's elements. For example, the tag <a href="/file"> will pass
'a' as the current tag, and a hash reference which contains
{'href'}="/file".

Notice: this function is slow! And using it to rewrite (via passback) is 
slower!  Make sure you have lw::bin installed to get the faster binary 
version.

=cut
sub html_find_tags {
 if(defined $available{'lw::bin'}){ # use faster binary helper
	goto &lw::bin::html_find_tags; }

 my ($dataref, $callbackfunc)=@_;

 my ($CURTAG, $ELEMENT, $VALUE, $c, $cc);
 my ($INCOMMENT,$INTAG)=(0,0);
 my (%TAG, $ret, $start, $tagstart, $commstart);


 for ($c=0; $c<length($$dataref); $c++){

	$cc=substr($$dataref,$c,1);

	if(!$INCOMMENT && !$INTAG && $cc ne '>' && $cc ne '<'){
		next;}

        if($cc eq '<'){
                if(substr($$dataref,$c+1,1) eq '!' && 
				substr($$dataref,$c+2,1) eq '-' && 
				substr($$dataref,$c+3,1) eq '-'){
                        $INCOMMENT=1; $commstart=$c; $c+=3;
		} else {
    	                $INTAG=1; $tagstart=$c; $c++;
			while(substr($$dataref,$c,1)!~/[ \t\r\n>]/){ 
				$c++;}
			$CURTAG=substr($$dataref,$tagstart+1,
				$c-$tagstart-1);
		}	
		$cc=substr($$dataref,$c,1); # refresh current char (cc)
	}

        if($cc eq '>'){
		if(!$INCOMMENT){ 
			$INTAG=0; 
			$ret=&$callbackfunc(lc($CURTAG),\%TAG, $dataref,
				$start, $c-$start+1);
			if(defined $ret && $ret != 0){
				$c+=$ret;}
			%TAG=();}
                if($INCOMMENT && substr($$dataref,$c-1,1) eq '-' && 
				substr($$dataref,$c-2,1) eq '-'){
                        $INCOMMENT=0; 
			$TAG{'='}=substr($$dataref,$commstart+4,
				$c-$commstart+1);
			$ret=&$callbackfunc('!--',\%TAG, $dataref,
				$commstart, $c-$commstart+1);
			if(defined $ret && $ret != 0){
				$c+=$ret;}
			next;}}

        if($INCOMMENT){ next; }

        if($INTAG){

                $ELEMENT=''; $VALUE='';
		while(substr($$dataref,$c,1)=~/[ \t\r\n]/i){ $c++;}

		$start=$c;
		while(substr($$dataref,$c,1)!~/[ \t\r\n=>]/i){ 
			$c++;}
		$ELEMENT=substr($$dataref,$start,$c-$start);

		while(substr($$dataref,$c,1)=~/[ \t\r\n]/i){ $c++;}

                if(substr($$dataref,$c,1) eq '='){ $c++;
			$start=$c;
                        if(substr($$dataref,$c,1) eq '"'){ $c++; $start++;
	                        while(substr($$dataref,$c,1) ne '"'){ 
					$c++; }
				$VALUE=substr($$dataref,$start,$c-$start);
                                $c++; 
			} else {
                                while(substr($$dataref,$c,1)!~/[ \t\r\n\>]/){
                                        $c++;}
				$VALUE=substr($$dataref,$start,$c-$start);
			}

                	while(substr($$dataref,$c,1)=~/[ \t\r\n]/){$c++;}
                } 
		$c--;
		$TAG{lc($ELEMENT)}=$VALUE; # save element in the hash
	}
}}

################################################################
