################################################################
sub utils_page_content_changes {
 my ($hreq,$times)=@_;
 my ($temp,%hout);

 &lw::http_do_request($hreq,\%hout);
 $temp=$hout{'whisker'}->{'data'};

 for(1..$times){
	&lw::http_do_request($hreq,\%hout);
	if($temp ne $hout{'whisker'}->{'data'}){ return 1; }
 }
 return 0;
}


################################################################
sub utils_vuln_reveals_source { # returns 1 if yes, 0 if no
 my ($hnorm, $hcheck, $stype)=@_; # takes normal hash, vuln hash,
 my (%hout,$temp);                # and optional server type

 &lw::http_do_request($hnorm,\%hout);
 $temp=$hout{'whisker'}->{'data'};

 # shitty situation: original page has source element(s)
 if($stype eq ''?utils_contains_source(\$temp,$stype):
	utils_contains_source(\$temp)){ return 0;}

 &lw::http_do_request($hcheck,\%hout);
 $temp=$hout{'whisker'}->{'data'};
 if($stype eq ''?utils_contains_source(\$temp,$stype):
	utils_contains_source(\$temp)){ return 1;}

 return 0;
}


################################################################
sub utils_contains_source {
 my ($S,$dref,$stype)=(0,shift,shift);

 if($stype eq '' || $stype=~/iis/){
 #### IIS source checks ####
 # ASPs
  if($$dref=~/<%/){ $S++; }
  if($$dref=~/<script[^>]+runat=("server"|server)[^>]*>/i){ $S++; }
 }

 if($stype eq '' || $stype=~/php/){
 #### PHP source checks ####
  if($$dref=~/<\?/){ $S++; }
  if($$dref=~/<%/){ $S++; }
 }

 if($stype eq '' || $stype=~/cgi/){	
 #### CGI source checks ####
  if($$dref=~m@^#\!/usr/(local/bin|bin)/perl@){ $S++; }
  if($$dref=~m@^#\!/bin/sh@){ $S++; }
 }

 return $S;
}


#################################################################
sub utils_URL { # laziness function
 my ($href,$host,$uri)=@_;
 $$href{'whisker'}->{'host'}=$host;
 $$href{'whisker'}->{'uri'}=$uri;}


#################################################################
sub utils_recperm {
 my ($p, $pp, $pn, $r, $fr)=@_;
 if($pp >= @$pn) { push @$r, $p unless $lw::internal_DIRS{$p}[1] >1;
 } else { my $c=$$pn[$pp];
 if($c!~/^\@/){
  recperm($p.'/'.$c,$pp+1,$pn,$r) if(&$fr($p.'/'.$c));
 } else { map { if(&$fr($p.'/'.$_)){
  recperm($p.'/'.$_,$pp+1,$pn,$r);}} 
	@{$c=~tr/\@//d&&$lw::internal_ARRS{$c}};}}}


#################################################################
sub utils_array_shuffle { # fisher yates shuffle....w00p!
        my $array=shift; my $i;
        for ($i = @$array; --$i;){
                my $j = int rand ($i+1);
                next if $i==$j;
                @$array[$i,$j]=@$array[$j,$i];
}} # end array_shuffle, from Perl Cookbook (rock!)


#################################################################
sub utils_randstr {
        my $str;
        my $drift=((rand() * 10) % 10)+10;
        for(1..$drift){
        $str .= chr(((rand() * 26) % 26) + 97);} # yes, we only use a-z
        return $str;}

#################################################################
sub utils_get_dir {
        my $URL=shift;
        $URL=~tr/ \t\r\n//d;
        $URL=~s/\/[^\/]*$//;
        if($URL!~/\/$/){ $URL.='/';}
        return $URL; }


#################################################################
sub utils_port_open {  # this should be platform-safe
        my ($target,$port)=@_;
        if(!(socket(S,PF_INET,SOCK_STREAM,0))){ return 0;}
        if(connect(S,sockaddr_in($port,inet_aton($target)))){
                close(S); return 1;
        } else { return 0;}}


#################################################################
=pod

=head1 - Function: lw::util_split_uri
  
Params: $uri_string
Return: @uri_parts

Return an array of the following values, in order:  uri, protocol, host,
port, params, frag, user, password.  Values not defined are given an undef
value.

=cut
sub utils_split_uri {
	my ($uri,$work,$w)=(shift,'',0);
	my @results=(undef,'http',undef,80,undef,undef,undef,undef);

	# handle mailto's (people miswrite them as mailto:email@host)
	if(index($uri,'mailto:',0) == 0){
		$res[1]='mailto';
		($res[0]=$uri)=~s/^mailto:[\/]{0,2}//;
		return @res; }

	# handle absolute urls
	if(index($uri,'://',0) > 0 ){ # fastpath check
	 if($uri=~m#^([a-z]+)://([^/]*)(.*)$#i){
		$res[1]=lc($1); 	# protocol
		$res[2]=$2;	    	# host
		$res[0]=$3;		# uri

		# check for port in host
		if(($w=index($res[2],':',0)) >=0){
			$res[3]=substr($res[2],$w,length($res[2])-$w,'');
			$res[3]=~tr/0-9//cd;
			$res[3]||=80;
		}

		while(($w=rindex($res[2],'@')) >=0){
			$work=substr($res[2],0,$w,'');
			$res[2]=~tr/@//d;
			if(($w=index($work,':',0)) >=0){
				$res[6]=substr($work,0,$w);
				$res[7]=substr($work,$w+1,length($work)-$2);
			} else {
				$res[6]=$work; }
		}

	 } else { $res[0]=$uri; }
	} else { $res[0]=$uri; }	

	# remove fragments
	if(($w=index($res[0],'#',0)) >=0){
		$res[5]=substr($res[0],$w+1,length($res[0])-$w,'');
		$res[0]=~tr/#//d; }

	# remove parameters
	if(($w=index($res[0],'?',0)) >=0){
		$res[4]=substr($res[0],$w+1,length($res[0])-$w,'');
		$res[0]=~tr/?//d; }
		
	return @res;
}

#################################################################

