#!/usr/bin/perl

# this script is an example on how to make a request
# using the libwhisker style of control

$|++;
use libwhisker;


my (%hin, %hout, %jar); 


# this sets up some standard values in the given hash
lw::http_init_request(\%hin);


# set the target host and URI
$hin{'whisker'}->{'host'}="cide.rfp.labs";
$hin{'whisker'}->{'uri'}="/";


# SSL support seems ok, but still reserves the right to be buggy
#$hin{'whisker'}->{'port'}="443";
#$hin{'whisker'}->{'ssl'}="1";


# special function to tweak the request to make sure it's valid HTTP 
# (not required if you set it all manually)
lw::http_fixup_request(\%hin);


# if there's any cookies in the %jar, then set them as appropriate
lw::cookie_write(\%jar,\%hin);


# actually make the request (and get response)
if(lw::http_do_request(\%hin,\%hout)){

	print 'ERROR: ', $hout{'whisker'}->{'error'}, "\n";
	print $hout{'whisker'}->{'data'}, "\n";

} else {

	# save any cookies sent to us into our %jar
	lw::cookie_read(\%jar,\%hout);

	print $hout{'whisker'}->{'http_resp'}, "\n";
	print $hout{'Server'}, "\n";
#	print $hout{'whisker'}->{'data'}, "\n";

}



